<?php
	session_start();
	define(APP_NAME, 'IHCC'); #'HTML/PHP Chat Client';
	define(VERSION, '0.3.9.9a');
	define(APP_NAME_VER, ".:. " . APP_NAME . " .:. Ver " . VERSION);
	$langfile = 'english.lang';
	
	// Files that are modified
	define(LOG_FILE, "msg.log");		// If you change this then read the readme
	define(MSG_FILE, "messages.txt");	// If you change this then read the readme
	define (USERSFILE, "online_users");
	define(TOPIC_FILE, "topic");
	
	// Debug and logging control
	define (DEBUG, 0); // Same as -v switch in other apps, add extra -v to increase level (i.e. 3 = -vvv)
	define (LOG, 1); // Wether to write log to LOG_FILE

	// Default Command Set, Can be overridden in language file
	// Commands (&Array)
	$commands = array (
		"clear"		=>	"clear",
		"forget"	=>	"logout",
		"logout"	=>	"logout",
		"me"		=>	"me",
		"ls"		=>	"ls",
		"log"		=>	"log",
		"topic"		=>	"topic"
	);
	$commands_disc = array (
		"clear"	=>	"Clears the messages window",
		"logout"	=>	"Remove the username from the online users list",
		"me"		=>	"Same as /me in IRC",
		"ls"		=>	"Lists all commands and a discription",
		"log"		=>	"Dumps the log file to the screen; Can have optional keywords for specific parts of the log. e.g. MSG"
	);
	$restricted_usernames = array ('all');
	// Language File Options
	require($langfile); // Load language file

	// Functions
	function login_form(){ // Display login form
		global $SCRIPT_NAME;
		html_page_header(LOGIN, 0, 0, 0);
		?>
		<h1><?php print APP_NAME_VER;?> :: <? print LOGIN;?></h1>
		<div class="login_form">
		<?php print ENTER_USERNAME;?>
		<form method="post" name="userlogin" action="<?php print $SCRIPT_NAME;?>">
		<input type="text" name="username" TABORDER="0"/>
		<input type="submit" value="<?php print LOGIN;?>"/>
		</form>
		<script>
			document.userlogin.username.focus();
		</script>
		<?php print LAST_MESSAGE;?> <?php print date('F jS, Y, \a\t g:i a',filemtime('messages.txt')); ?>
		</div><br>
		<?php print WARNING;?>
		<?
		html_page_footer(1);
	}
	function user_mod($action,$data){
		file_check(USERSFILE);
		global $HTTP_USER_AGENT;
		$data = trim($data);
		switch ($action){				// Select Action
			case 'add';				// add user to file
				if (DEBUG) print "Adding User <em>$data</em> To File";
				$file_add = fopen(USERSFILE, 'a');
				fwrite($file_add, $data ."\n");
				fclose($file_add);
				msglog("USR | User '".$data."' logged in using '$HTTP_USER_AGENT'");
				return '';
				break;
			case 'clear';
				if (DEBUG) print "Clearing online users file<br>";
				msglog("USR | Cleared online users file");
				fclose(fopen(USERSFILE, 'w'));
				break;
			case 'remove';				// remove user from file
				if (DEBUG) print "Removing User from File<br>";
				$online = file (USERSFILE);
				$file_remove = fopen(USERSFILE, 'w');
				$userfound = 0;
				while(list ($usernum, $online_user) = each ($online)){
					//$userline = $data; // Search string
						if (DEBUG>=2) print "Searching for $data<br>Line in file is " . safe($online_user) . "<br>";
					#if (preg_match($userline, addslashes($online_user)) && $userfound == 0){// User logging out
				//	if (DEBUG) print "Onlineuser = '$online_user'<br>Data = '$data'<br>";
					if (DEBUG) print (trim($data) == trim(safe($online_user))) . "<br>";
					if (($data == trim(safe($online_user))) && ($userfound == 0)){
						if (DEBUG>=2) print "User found<br>";
						$userfound = 1;
						msglog("USR | Removed user '".$data."' from online file");
					}else{
						fwrite($file_remove, $online_user);
					}
				}
				fclose($file_remove);
				return '';
				break;
			case 'dump';			// dump user file
				$online_users_list = file('online_users');
				foreach ($online_users_list as $username){
					if (trim($username) != '') print "- " . trim(safe($username)) . "<br>";
				}
				return '';
				break;
			default;			// Invalid User File Mod
				if(DEBUG) print "Invalid User File Modifcation Call<br>";
				break;
		}
	}

	function msg_mod($action, $data){
		file_check(MSG_FILE);
		switch($action){
			case "dump";		// Output Message File
				$messages = file(MSG_FILE);
				$topic = file(TOPIC_FILE);
				?><div class="spacer">&nbsp;</div>
				<div class="topic">
					<b>
						<div class="topicis"><?php print TOPIC;?></div>
						<em><?php print $topic[0]?></em>
					</b>
					<br>
				</div>
				<div class="spacer">&nbsp;</div>
				<?php
				foreach ($messages as $msg) {
					if (trim($msg) != '') print trim($msg)."<br>\n";
				}
				break;
			case "clear";		// Clear Message File
				if (DEBUG) print "Clearing Message window file<br>";
				msglog('FILE | Message File Cleared');
				fclose(fopen('messages.txt', 'w'));
				break;
			case "add";		// Append msg
				$msg_file = fopen(MSG_FILE, 'a');
				msglog("MSG | $data");
				if(fwrite($msg_file, $_SESSION['user']." | $data\n")==-1) die(MSG_FILE_ERR);
				fclose($msg_file);
			# Code to update check file. Will probably be obsolete soon or moved to funct
				/*	$new_file = fopen('new','w');
					fwrite($new_file, '1');
					fclose($new_file);*/
				return '';
				break;
			case "action";		// Action msg
				$msg_file = fopen(MSG_FILE, 'a');
				msglog("ACT | ".$_SESSION['user']. " " .$data);
				if(fwrite($msg_file, "<b>" . $_SESSION['user'] . " $data</b>\n")==-1) die(MSG_FILE_ERR);
				fclose($msg_file);
				return '';
				break;			
			case "remove";		// Remove Single Message
				break;
			default;		// Invalid MSG File Mod
				if (DEBUG) print "Invalid Message File Modification Call<br>";
				break;
		}
	}

	function topic($new_topic){
		file_check(TOPIC_FILE);
		$file = fopen (TOPIC_FILE, "w");
		fwrite($file, $new_topic);
		fclose($file);
		return "";
	}

	function output_messages(){ // Output Message Frame
		html_page_header(MESSAGES, 3, 'body {margin-right: 0%; margin-left: 0.5em}', 1);
		?>
		<?php msg_mod('dump','');

//		<script language="Javascript">
//		yLength = DOMElementGetHeight(DOMObjects['bodyArea']) -
//      DOMWindowGetInnerHeight();
//		window.scrollBy(0, 10000);
//		document.write(yLength);
//		</script>
		
		html_page_footer(0);
	}
	function output_userlist(){ // Output Online Users List Frame
		html_page_header(USERS, 3, 'body {margin-right: 0%; margin-left: 1em}', 0);
		?>
		<div class="userhead"><b>
		<?php print ONLINE_USERS;?>
		</b></div>
		<?php
		user_mod('dump','');
		html_page_footer(0);
	}

	function file_check($filename){ // Checks that file exists and is writeable.
					// Should only be called for files that need modification
					// Takes filename as argv
					// returns true if safe else dies and kills script
		clearstatcache();
		if (!(file_exists($filename) && is_writable($filename))) {
			if($filename != LOG_FILE) msglog("FILE | $filename not writeable. See README");
			die("$filename isn't writeable<br>Please contact the scripts owner<br>If you are the owner please read the README or 'chmod 0666 $filename'<br>");
			return 0;
		}
		return 1;
	}

	function msglog($message){	// Adds new message to log file IF logging is enabled (LOG == 1)
					// Takes log message as argv. Automagically adds time, date, ip, user and more
		if(LOG){
			file_check(LOG_FILE);
			global $REMOTE_ADDR, $SERVER_SIGNATURE, $SCRIPT_NAME, $HTTP_USER_AGENT;
			$log_file = fopen(LOG_FILE, 'a');
			clearstatcache();
			if(filesize(LOG_FILE)<2) fwrite($log_file, "Starting log file '" . LOG_FILE . " on " . date("Ymd H:i:s") . $SERVER_SIGNATURE . " for script '$SCRIPT_NAME'\n");
			if ((fwrite($log_file, date("Ymd H:i:s")." | ".$_SESSION['user']." from $REMOTE_ADDR | $message\n"))==-1){
				die(LOG_FILE_ERR);
			}
			fclose($log_file);
		}
	}

	function dump_msglog($filter){
		file_check(LOG_FILE);
		global $SERVER_SIGNATURE;
		$messages = file(LOG_FILE);
		msglog('FILE | Log File Accessed');
		print "Log File ". LOG_FILE ." on ".$SERVER_SIGNATURE. "-------------------------<br>";
		if ($filter) print "Filtering with $filter<br>-------<br>";
		foreach ($messages as $msg) {		
			if (!$filter || (preg_match('/ ' . $filter . ' /', $msg))){
			if (trim($msg) != '') {
				if (preg_match('| ACT |', $msg)){
					print "<b><em>". $msg. "</em></b><br>";
				}elseif (preg_match('| MSG |', $msg)){
					print "<b>". $msg. "</b><br>";
				}else print $msg . "<br>";
			}
			}
		}
		
	}

	function command($data){
		global $commands, $commands_disc;
		if (preg_match('/^\/([a-zA-Z]*)\s*(.*)/',$data,$command)){
			if (DEBUG) print 'You have typed the command /' . $commands[$command[1]] . "<br>";
			if($commands[$command[1]]){
				msglog("CMD | Command '".$data."' issued");
				switch ($commands[$command[1]]){
					case 'ls';
						$output = "<DL>";
						foreach ($commands_disc as $cmd => $discp) {
							  $output .= "<dt>$cmd</dt><dd>$discp</dd>";
							  
						}
						$output .= "</DL>";
						print $output;
						break;
					case 'clear'; // Clear messages file (With command '/clear'
						$msg = msg_mod('clear','');
						break;
					case 'logout';
						if ($command[2]=="all"){
							  user_mod('clear', 0);
						}
						if (DEBUG) print "Removing user $command[2] from list<br>";
						msglog("USR | User '".$command[2]."' (manually) removed from online list");
						$msg = user_mod('remove', $command[2]);
						break;
					case 'me';
						if (DEBUG) print "Sending action msg as <em>".$_SESSION['user']."</em><br>";
						msg_mod('action', $command[2]);
						break; // Can't finish until MSG file actions in sub
				#	case 'reset';
				#		if (DEBUG) print "Resetting Server to initial state<br>";
				#		break; //To be done l8r
					case 'log';
						if (DEBUG) print "Dumping Log File<br>";
						dump_msglog($command[2]);
						break;
					case 'topic';
						if (DEBUG) print "Setting new topic to $command[2]<br>";
						$msg = topic($command[2]);
						break;
					default;
						msglog("CMD | Command '$data' not implemented yet");
						print COMMAND_NOT_IMP."<br>";
						break;
				}
			}else{
				msglog("CMD | Invalid command issued. '".$data."'");
				print INVALID_COMMAND;
			}
			return 1;
		}else{
			return 0;
		}
	}

	function message_handler(){
		file_check(MSG_FILE);
		global $invalid_msg;
		if($_POST['msg']){// Get data from form and add to file
			$msg = $_POST['msg'];
			
			// Make message safe and display warning if it contains invalid char
			if (preg_match('[frame|src=|javascript|<.*>]', $msg)){ // Set flag to display warning
				$invalid_msg= 1;
			}
			$msg = safe(stripslashes($msg)); // Make ALL messages sage
			
			// Check if msg is a valid command and execute command
			if (!command($msg)){	// Put message in file
				$msg = msg_mod('add', $msg);
			//	$msg = '';
			}
		}
		return 1;
	}

	function login(){
		  global $restricted_usernames;
		// Log user in and store settings/username
		if(!session_is_registered('user')){ // Checks if session is registered
			if ($_POST['username']){ // Registers user login
				//	# Possible addition 
					# Check usersname is in offline file and not online file (User authentication method)
			//	session_register('user');
				$_SESSION['user'] = stripslashes(safe($_POST['username']));
				if (in_array($_SESSION['user'], $restricted_usernames)){
					  session_destroy();
					  $output = "Invalid Username<br>";
					  print $output;
					  login_form();
					  return 0;
				}
				if (DEBUG) print "New Session started with user <em>".$_SESSION['user']."</em><br>";
				//				$output = 1;
				// Add username to online file
				user_mod('add',$_SESSION['user']);
				return 1;
			}else{// Out put user login
				login_form();
				return 0;
			}
		}
		return 1;
	}

	function logout_check(){
	//	global $user;
		if($_POST['logout']){// LOGOUT USER
			html_page_header(LOGOUT, 1, 0, 0);
			//rem_user($user);
			if (DEBUG) print "Logging out <i>".$_SESSION['user']."</i><br>";
			msglog("USR | Logging user '".$_SESSION['user']."' out of system by request");
			user_mod('remove',$_SESSION['user']);
			?><a href="<?php print $SCRIPT_NAME;?>"><?php print LOGGING_OUT;?></a><?
			html_page_footer(0);
			session_destroy();
			return 0;
		}
		return 1;
	}

	function page_output(){
		if ($_GET['msg_output']){
			output_messages();
			return 0;
		}elseif($_GET['user_list']){
			output_userlist();
			return 0;
		}else{
			return 1;
		}
	}
	
	function main_disp(){	//Output form to post data with and messages
		global $invalid_msg;
		html_page_header(MAIN, 0, 0, 0);
		?>
		<h1><?php print APP_NAME_VER;?></h1>
		<div class="username">
			<?php print LOGGED_IN_USERNAME;?>
			<b><?php print $_SESSION['user'];?></b>
		</div>
		<?php print INSTRUCTIONS;?><br>
		<iframe src="<?php print $SCRIPT_NAME;?>?msg_output=1" class="message" name="messages"></iframe>
		<iframe src="<?php print $SCRIPT_NAME;?>?user_list=1" class="userlist" name="users"></iframe><br>

		<form method="post" action="<?php print $SCRIPT_NAME;?>" class="message" name="chat">
			<input type="text" name="msg" value="<?php print $msg ?>" class="text_input" taborder="1" />
			<script>
				document.chat.msg.focus();
			</script>
			<input type="submit" value="<?php print SEND_MESSAGE;?>" />
			<input type="submit" name="logout" value="<?php print LOGOUT;?>">
		</form><?
/*		<div class="logout">
			<form method="post" action="<?php print $SCRIPT_NAME;?>" class="logout">
			<input type="submit" name="logout" value="<?php print LOGOUT;?>">
			</form>
		</div>*/?>
		<?php
		if ($invalid_msg){
			?><div class="error"><?php print INVALID_DATA;?></div><?php
		}
		?>
		<div class="new"><?php print COMING_SOON;?> <?php print APP_NAME;?> ... <br><?php print NEW_FEATURES;?></div>
		<?
		html_page_footer(1);
	}

	function html_page_header($title, $refresh, $extra_style, $scroll){
		?>
		<html>
			<head>
				<title><?php print APP_NAME_VER;?><? if ($title) {?> :: <?print $title;}?></title>
				<? if ($refresh) {
					?><META HTTP-EQUIV=Refresh CONTENT="<? print $refresh;?>">
					<?}?>
				<? css();
				if ($extra_style) {?><STYLE type="text/css"><? print $extra_style;?></style><?}?>
			</head>
			<? if ($scroll){?>
			<body onLoad='window.scroll(0,100000)'>
			<?}else{?>
			<body>			
		<?}
	}
	function html_page_footer($ads){
		if($ads){
		?>		<div class="ad_banner">
					<a href="http://www.spreadfirefox.com/?q=affiliates&amp;id=0&amp;t=90">
<!--						<img border="0" alt="Get Firefox!" title="Get Firefox!" src="http://www.spreadfirefox.com/images/affiliates/Banners/120x240/rediscover.png"/>-->
						<img border="0" alt="Get Firefox!" title="Get Firefox!" height="60" width="480" src="trust.png"/>
					</a>
				</div>
		<?}?>
			</body>
		</html>	
		<?
	}

	function css(){	// Standard CSS for all pages, some pages have extra in their function
		?>
		<STYLE type="text/css">
			.error {
				font-family: Verdana, Arial, Helvetica, sans-serif;
				color: red;
				background: black;
       				font-weight: bold;
			}
			.new {
				font-family: Verdana, Arial, Helvetica, sans-serif;
				color: orange;
			       	background: black;				
		       	}
			body {
				font-family: Verdana, Arial, Helvetica, sans-serif;
				background: gray;
				margin-right: 5%; margin-left:5%				
			}
			.username {
				text-align: right;
				font-size: smaller;
				position: relative; 
				top: 15;				
			}
			.topic {
				text-align: right;
				font-size: smaller;
				position: fixed;
				top: 0.5em;
/*				left: auto;*/
				width: 95%;
/*				right: 1em;
				left: 1em;*/
				background: #00ff00;
/*				margin-left:	1em;
				margin-right:	1em;
				margin-top:	3px;
				margin-bottom:	3px;*/
			}
			.topicis {
				text-align: left;
			}
			pre {
				font-family: Verdana, Arial, Helvetica, sans-serif;
			}			
			h1 {
				text-align: center;
				font-family: Verdana, Arial, Helvetica, sans-serif;
			}
			.text_input {
				font-family: Verdana, Arial, Helvetica, sans-serif;
				width: 60%;
			}
			iframe {
				height: 300;
			}
			iframe.message {
				width: 79%;
			}
			iframe.userlist {
				width: 19%;
			}
			.userhead {
				text-indent: -0.5em;
			}
			img {
				align: center;
				/*margin-left: 50%;
				margin-right: 50%;*/
			}
			.ad_banner {
				border: 1px solid rgb(102, 102, 102);
				margin: 2pt auto;
				padding: 2px;
				width: 90%;
				background-color: rgb(154, 170, 170);
				text-align: center;
			}
/*			.container {
				text-align: center;
			}*/
			div.spacer {
				clear: both;
			}

		</style>
		<?php
	}
	function safe($document){
		// $document should contain an HTML document.
		// This will remove HTML tags, javascript sections
		// and white space. It will also convert some
		// common HTML entities to their text equivalent.

		$search = array ("'<script[^>]*?>.*?</script>'si",  // Strip out javascript
			"'<[\/\!]*?[^<>]*?>'si",           // Strip out html tags
			"'([\r\n])[\s]+'",                 // Strip out white space
			"'&(quot|#34);'i",                 // Replace html entities
			"'&(amp|#38);'i",
			"'&(lt|#60);'i",
			"'&(gt|#62);'i",
			"'&(nbsp|#160);'i",
			"'&(iexcl|#161);'i",
			"'&(cent|#162);'i",
			"'&(pound|#163);'i",
			"'&(copy|#169);'i",
			"'&#(\d+);'e");                    // evaluate as php

		$replace = array ("",
			"",
			"\\1",
			"\"",
			"&",
			"<",
			">",
			" ",
			chr(161),
			chr(162),
			chr(163),
			chr(169),
			"chr(\\1)");
		if (DEBUG) print "Striping data from $document<br>";
		return preg_replace ($search, $replace, $document);
	}		

	if (login()) if (logout_check()) if (page_output()) if(message_handler()) main_disp();

?>
